/*
 * dma.c
 *
 *  Created on: May 27, 2014
 *      Author: B21665
 */
#include "derivative.h" /* include peripheral declarations */
#include "dma.h"


/********************************************************************/
void K70_DMA_init(void)
{

	SIM_SCGC6 |= SIM_SCGC6_DMAMUX0_MASK;
	SIM_SCGC7 |= SIM_SCGC7_DMA_MASK;

	/*Enable DMA MUX ch 0*/
	DMAMUX0_CHCFG0 |= DMAMUX_CHCFG_ENBL_MASK | DMAMUX_CHCFG_SOURCE(6); //Enable channel 0, Request souurce = UART 2 Receive
	
	/*Start the sequence*/
	DMA_ERQ |= DMA_ERQ_ERQ0_MASK|DMA_ERQ_ERQ1_MASK;     

	/*** Initialize CH0 -> 1 byte received from UART 2 ***/ 

	/* Set the Source Address*/ 
	DMA_TCD0_SADDR = (uint32_t)(&UART2_D); //UART2_D 0x4006C007
	
	/* Destination address */
	DMA_TCD0_DADDR = (uint32_t)(&RAM_START_ADDRESS);
	
	/* Source offset*/
	DMA_TCD0_SOFF = 0; // No offset
	
	/*Modulo off and port sizes*/
	//DMA_TCD0_ATTR = DMA_ATTR_SSIZE(4) | DMA_ATTR_SMOD(0) | DMA_ATTR_DSIZE(4) | DMA_ATTR_DMOD(0);   //16-byte burst
	DMA_TCD0_ATTR = DMA_ATTR_SSIZE(0) | DMA_ATTR_DSIZE(0);	//source and destination size 0 = 8 bits
	
	/* Transfer size */
	DMA_TCD0_NBYTES_MLNO = 1; //1 byte
	
	/* No adjustment to	source address */
	DMA_TCD0_SLAST = 0;//-32
	
	/* Destination offset*/
	DMA_TCD0_DOFF = 1; //1 byte
	
	/* No link channel, transactions */
	DMA_TCD0_CITER_ELINKNO = 1; //1 major loop
	
	/* Adjustment to destination address */
	DMA_TCD0_DLASTSGA = 0;//-32
	
	/* No link channel, transactions */
	DMA_TCD0_BITER_ELINKNO = 1; //1 major loop

	/*...*/
	//DMA_TCD0_CSR = DMA_CSR_DREQ_MASK; //Clear channel's ERQ bit when major loop is complete
	DMA_TCD0_CSR = 0; //Never clear channel's ERQ bit

}
