/*
 * main implementation: use this 'C' sample to create your own application
 *
 */


#include "derivative.h" /* include peripheral declarations */

#include "arm_cm4.h"
#include "spi.h"
#include "dma.h"

int main(void)
{

	SIM_SCGC5 |= SIM_SCGC5_PORTC_MASK;	
	PORTC_PCR1 |=PORT_PCR_MUX(0x01) | PORT_PCR_IRQC(0x02)|PORT_PCR_PE_MASK|PORT_PCR_PS_MASK; //sw1
	
	uint8_t count = 0;
	SPI0_mstrInit();      //SPI master init
	EnableInterrupts;
	enable_irq(INT_DMA0 - 16);
	enable_irq(INT_DMA1 - 16);
	enable_irq(INT_DMA2 - 16);
	
	vfnInitDMA_SPITxMstr();        //Enable the DMA channel 0 for  SPI transmit
	vfnInitDMA_SPIRxMstr();		   //Enable the DMA channel 1 for  SPI receive
	vfnInitDMA();				  // Enable the DMA channel 2 for Enable TX SPI 

	for(;;) {
		MasterDataSend (count); //Filling the buffer
		Master_sendDMA();       //Sending data
		count++;
		if(count >= 3){count = 0;}	
	}
	
}



