/*
 * dma.c
 *
 *  Created on: Jun 24, 2014
 *      Author: B50274
 */

#include "dma.h"




void vfnInitDMA_SPITxMstr(void)
{
  SIM_SCGC6 |= SIM_SCGC6_DMAMUX_MASK;
  SIM_SCGC7 |= SIM_SCGC7_DMA_MASK;
  /**********************************************************************************************************************************/
  /**********************************************************************************************************************************/
  /* Look for the DMA request sources table on your RM for a complete list of available sources */
  DMAMUX_CHCFG0 |= DMAMUX_CHCFG_ENBL_MASK | DMAMUX_CHCFG_SOURCE(17); //SPI0 TX 
   /*start the sequence*/
  //DMA_ERQ |= DMA_ERQ_ERQ0_MASK;
  /* This example has no table of data to											    */
	/* transfer, making only a single minor loop necessary to complete a major loop		*/
  DMA_TCD0_SADDR =  (uint32_t)&MstrDataSend_Buff;	//Source address
  /* Destination address */
  DMA_TCD0_DADDR = (unsigned long)(&SPI0_PUSHR); //
	/* Source offset disabled */
  DMA_TCD0_SOFF = 0x04;
	/* Source and Destination Modulo off, source and destination size 2 = 32 bits */
  DMA_TCD0_ATTR = DMA_ATTR_SSIZE(2) | DMA_ATTR_DSIZE(2);	
	/* Transfer 4 bytes per transaction */
  DMA_TCD0_NBYTES_MLNO = 0x04;
	/* No adjust needed */
  DMA_TCD0_SLAST = -32;
	/* Destination offset disabled */
  DMA_TCD0_DOFF = 0x00;
	/* No link channel to channel, 1 transaction */
  DMA_TCD0_CITER_ELINKNO = DMA_CITER_ELINKNO_CITER(8);
	/* No adjustment to	destination address */
  DMA_TCD0_DLASTSGA = 0;
	
  DMA_TCD0_BITER_ELINKNO = DMA_BITER_ELINKNO_BITER(8); 

  DMA_TCD0_CSR = DMA_CSR_INTMAJOR_MASK | DMA_CSR_DREQ_MASK; 
  

}



void vfnInitDMA_SPIRxMstr(void)
{
  /* Look for the DMA request sources table on your RM for a complete list of available sources */
  DMAMUX_CHCFG1 |= DMAMUX_CHCFG_ENBL_MASK | DMAMUX_CHCFG_SOURCE(16); //SPI0 TX 
   /*start the sequence*/
  DMA_ERQ |= DMA_ERQ_ERQ1_MASK;
  /* This example has no table of data to											    */
	/* transfer, making only a single minor loop necessary to complete a major loop		*/
  DMA_TCD1_SADDR =  (uint32_t)(&SPI0_POPR);	//Source address
  /* Destination address */
  DMA_TCD1_DADDR = (uint32_t)&MstrDataRcv_Buff; //
	/* Source offset disabled */
  DMA_TCD1_SOFF = 0x00;
	/* Source and Destination Modulo off, source and destination size 2 = 32 bits */
  DMA_TCD1_ATTR = DMA_ATTR_SSIZE(2) | DMA_ATTR_DSIZE(2);	
	/* Transfer 4 bytes per transaction */
  DMA_TCD1_NBYTES_MLNO = 0x04;
	/* No adjust needed */
  DMA_TCD1_SLAST = 0;
	/* Destination offset disabled */
  DMA_TCD1_DOFF = 0x04;
	/* No link channel to channel, 1 transaction */
  DMA_TCD1_CITER_ELINKNO = DMA_CITER_ELINKNO_CITER(8);
	/* No adjustment to	destination address */
  DMA_TCD1_DLASTSGA = -32;
	
  DMA_TCD1_BITER_ELINKNO = DMA_BITER_ELINKNO_BITER(8); 

  DMA_TCD1_CSR = DMA_CSR_INTMAJOR_MASK;
  
 
}



void DMA0_isr(void)
{
	DMA_CINT |= DMA_CINT_CINT(0);
	if(DMA_TCD0_CSR & DMA_CSR_DONE_MASK){
		DMA_CDNE |= DMA_CDNE_CDNE(0);
		//SPI0_RSER &= ~SPI_RSER_TFFF_RE_MASK;    //Stop the request to the DMA
	}

}

void DMA1_isr(void)
{	
	DMA_CINT |= DMA_CINT_CINT(1);
	if(DMA_TCD1_CSR & DMA_CSR_DONE_MASK){
		DMA_CDNE = DMA_CDNE_CDNE(1);
		//SPI0_RSER &= ~SPI_RSER_TFFF_RE_MASK;    //Stop the request to the DMA
	}
}


